package ru.yandex.atom.utils

import com.typesafe.config.{ConfigRenderOptions, Config}
import scala.concurrent.duration.{FiniteDuration, Duration}
import java.util.concurrent.TimeUnit
import scala.collection.JavaConversions._

/**
 * @author avhaliullin
 */
package object config {

  implicit class RichConfig(val config: Config) extends AnyVal {
    def getFiniteDuration(path: String): FiniteDuration = {
      Duration.fromNanos(config.getDuration(path, TimeUnit.NANOSECONDS))
    }

    def prettyPrint: String = {
      val sb = StringBuilder.newBuilder
      config.entrySet().foreach {
        kv =>
          sb.append(kv.getKey + " = " + kv.getValue.render(ConfigRenderOptions.concise()) + "\n")
      }
      sb.toString()
    }
  }

}
