package ru.yandex.autodoc.common.doc.abstracts;

import ru.yandex.autodoc.common.doc.error.MethodErrorsDoc;
import ru.yandex.autodoc.common.doc.params.ParamsDoc;
import ru.yandex.autodoc.common.doc.result.MethodResultDoc;

/**
 * Содержит информацию, которую ручка должна знать о себе - он должна знать, какие параметры принимает, что отдает,
 * требуется ли авторизация
 * @author avhaliullin
 */
public interface ServantletWithDocumentation extends ParamsDoc, MethodResultDoc, MethodErrorsDoc {
    public boolean needAuthorization();

    public String definedInContext();
}
