package ru.yandex.webmaster3.api.links.action;

import ru.yandex.autodoc.common.doc.annotation.Description;
import ru.yandex.webmaster3.api.host.filter.trait.AbstractApiUserVerifiedHostRequest;
import ru.yandex.webmaster3.api.links.ExternalLinksHistoryLocator;
import ru.yandex.webmaster3.api.links.data.ApiExternalLinksIndicator;
import ru.yandex.webmaster3.core.http.RequestQueryProperty;

import java.util.Set;

/**
 * @author avhaliullin
 */
public class ExternalLinksHistoryRequest extends AbstractApiUserVerifiedHostRequest<ExternalLinksHistoryLocator> {
    private Set<ApiExternalLinksIndicator> indicators;

    public Set<ApiExternalLinksIndicator> getIndicators() {
        return indicators;
    }

    @Description("Список индикаторов для отображения")
    @RequestQueryProperty(required = true)
    public void setIndicators(Set<ApiExternalLinksIndicator> indicators) {
        this.indicators = indicators;
    }
}
