package ru.yandex.webmaster3.core.semantic.review_business.model.impl;

/**
 * Holder for attribute names
 * of {@link ru.yandex.webmaster3.core.semantic.review_business.model.Author}.
 * <p/>
 * Attribute names must be equals to ones in BizReview.xsd
 *
 * @author Dima Schitinin <dimas@yandex-team.ru>
 */
public final class AuthorAttributes {

    private AuthorAttributes() {
        throw new UnsupportedOperationException("Not expected to be instantiated");
    }

    public static final String HCARD = "hcard";

    public static final String VCARD = "vcard";

    public static final String FN = "fn";

    public static final String LOGIN = "login";

    public static final String DISPLAY_NAME = "display-name";

    public static final String SIGN_PRIVACY = "sign-privacy";

    public static final String URL = "url";

    public static final String EMAIL = "email";

    public static final String AVATAR = "avatar";

    public static final String THANKS = "thanks";

    public static final String AUTHPOST = "authpost";

    public static final String AUTHCOMMENTS = "authcomments";

    public static final String FRIENDS = "friends";

    public static final String KARMA = "karma";

    public static final String REGDATE = "regdate";

    public static final String SOCIALS = "socials";

    public static final String SOCIAL = "social";
}

