package ru.yandex.webmaster3.core.tracer;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Stream;

import org.springframework.stereotype.Component;

import ru.yandex.webmaster3.core.worker.task.PeriodicTaskType;
import ru.yandex.webmaster3.core.worker.task.WorkerTaskType;

/**
 * @author kravchenko99
 * @date 12/6/21
 */

@Component
public class WorkerTraceTargets implements TraceTargets{

    @Override
    public List<String> getTargets() {
        return Stream.concat(Arrays.stream(PeriodicTaskType.values()).map(Enum::name), Arrays.stream(WorkerTaskType.values()).map(Enum::name)).toList();
    }
}
