package ru.yandex.webmaster3.internal.user.domain.verification;

import ru.yandex.autodoc.common.doc.annotation.Description;
import ru.yandex.webmaster3.core.host.verification.VerificationType;
import ru.yandex.webmaster3.core.http.ActionResponse;

import java.util.Set;

/**
 * @author avhaliullin
 */
public class DomainApplicableVerificationsResponse implements ActionResponse.NormalResponse {
    private final Set<VerificationType> applicableVerifications;

    public DomainApplicableVerificationsResponse(Set<VerificationType> applicableVerifications) {
        this.applicableVerifications = applicableVerifications;
    }

    @Description("доступные способы верификации")
    public Set<VerificationType> getApplicableVerifications() {
        return applicableVerifications;
    }
}

