package ru.yandex.webmaster3.storage.searchurl.samples.data;

import ru.yandex.autodoc.common.doc.annotation.Description;

/**
 * @author avhaliullin
 */
public class MemorandumSample {
    private final String path;
    private final String url;
    private final String copyrightObject;
    private final String copyrightOwner;

    public MemorandumSample(String path, String url, String copyrightObject, String copyrightOwner) {
        this.path = path;
        this.url = url;
        this.copyrightObject = copyrightObject;
        this.copyrightOwner = copyrightOwner;
    }

    @Description("относительный урл")
    public String getPath() {
        return path;
    }

    @Description("абсолютный урл")
    public String getUrl() {
        return url;
    }

    @Description("объект копирайта (Сериал \"Ольга\")")
    public String getCopyrightObject() {
        return copyrightObject;
    }

    @Description("владелец копирайта (АО «ТНТ-Телесеть»)")
    public String getCopyrightOwner() {
        return copyrightOwner;
    }
}
