#pragma once

#include <cstddef>

namespace NWebmaster {
namespace NTurbo {

enum TURBO_SOURCE_FLAGS {
    AUTOPARSER          = 1UL,
    AUTOPARSER_BUTTON   = 1UL << 1,
    RSS                 = 1UL << 2,
    YML                 = 1UL << 3,
    API                 = 1UL << 4,
    YML_LISTING         = 1UL << 5,
    AUTO_MORDA          = 1UL << 6,
};

size_t GetYMLFlags(size_t flags) {
    return flags & (YML | YML_LISTING);
}

size_t GetNoYMLFlags(size_t flags) {
    return flags & ~(YML | YML_LISTING);
}

} //namespace NTurbo
} //namespace NWebmaster
