#pragma once

// processing logs and common
static const char* FIELD_SOURCE = "source";
static const char* FIELD_SOURCES = "sources";
static const char* FIELD_ACTION = "action";
static const char* FIELD_FEED = "feed";
static const char* FIELD_WMC_HOST = "wmc_host";
static const char* FIELD_DOMAIN = "domain";
static const char* FIELD_TYPE = "type";
static const char* FIELD_FEEDS = "feeds";
static const char* FIELD_DOMAINS = "domains";
static const char* FIELD_DOCUMENT = "document";
static const char* FIELD_LINK = "link";
static const char* FIELD_PREVIEW = "preview";
static const char* FIELD_ITEMS = "items";
static const char* FIELD_ERRORS = "errors";
static const char* FIELD_EVENTS = "events";
static const char* FIELD_STATS = "stats";
static const char* FIELD_LAST_ACCESS = "last_access";
static const char* FIELD_SAAS_KEY = "saas_key";
static const char* FIELD_CODE_PUBLIC = "code_public";
static const char* FIELD_CODE = "code";
static const char* FIELD_SEVERITY = "severity";
static const char* FIELD_DETAILS = "details";
static const char* FIELD_URL = "url";
static const char* FIELD_ITEM_URL = "item_url";
static const char* FIELD_LINE = "line";
static const char* FIELD_COLUMN = "column";
static const char* FIELD_CONTEXT = "context";
static const char* FIELD_HASH = "hash";
static const char* FIELD_TITLE = "title";
static const char* FIELD_COUNT = "count";
static const char* FIELD_META = "meta";
static const char* FIELD_FEED_URL = "feed_url";
static const char* FIELD_DATA = "data";
static const char* FIELD_TIMESTAMP = "timestamp";
static const char* FIELD_ACTIVE = "active";
static const char* FIELD_STATE = "state";


// turbo bans
static const char* FIELD_HOST = "host";
static const char* FIELD_KEY = "key";
static const char* FIELD_FEED_BAN_RULES = "feed_ban_rules";
static const char* FIELD_DOC_BAN_RULES = "doc_ban_rules";
static const char* FIELD_FEED_BAN_SAMPLES = "feed_ban_samples";
static const char* FIELD_DOC_BAN_SAMPLES = "doc_ban_samples";
static const char* FIELD_STILL_BANNED = "still_banned";
static const char* FIELD_MARKER = "marker";
static const char* FIELD_TABLE = "table";
static const char* FIELD_BAN_ID = "ban_id";
static const char* FIELD_BAN_TYPE = "ban_type";
static const char* FIELD_BAN_REASON = "ban_reason";
static const char* FIELD_BAN_ERROR = "ban_error";
static const char* FIELD_DESCRIPTION = "description";
static const char* FIELD_APPLY_TIMESTAMP= "apply_timestamp";
static const char* FIELD_BAN_SAMPLES = "ban_samples";

static const char* SOURCE_WEBMASTER = "webmaster";
static const char* SOURCE_API = "api";
static const char* SOURCE_RSS = "rss";
static const char* SOURCE_YML = "yml";
static const char* SOURCE_AUTOPARSER = "autoparser";
static const char* SOURCE_AUTOPARSER_BUTTON = "autoparser_button";

// intermediate
static const char* F_SOURCE_TABLE = "source_table";

// output fields
static const char* F_RSS_FEEDS = "rss_feeds";
static const char* F_YML_FEEDS = "yml_feeds";
static const char* F_BANS = "bans";
static const char* F_AUTORELATED_SAMPLES = "autorelated_samples";
static const char* F_AUTOMORDA_SAMPLES = "automorda_samples";
static const char* F_AUTOMORDA_STATUS = "automorda_status";
static const char* F_APP_REVIEWS_INFO = "app_reviws_info";
static const char* F_AUTOPARSER_SAMPLES = "autoparser_samples";
static const char* F_COMMERCE_CATEGORIES = "commerce_categories";
static const char* F_EXPERIMENT = "experiment";
static const char* F_LISTINGS_INFO = "listings_info";
static const char* F_MARKET_FEEDS = "market_feeds";
static const char* F_PREMODERATION_RESULT = "premoderation_result";
static const char* F_BANNED_SCC = "banned_scc";
static const char* F_SHOP_STATES = "shop_states";
static const char* F_PROBLEMS = "problems";
static const char* F_ACTUAL_SINCE = "actual_since";
static const char* F_LAST_UPDATE = "last_update";
